#
# @(#)Title.....IMSADMIN - EMWAC's IMS Administrator
# @(#)Author....dada    (05.07.96) 
# @(#)Version...0.80.08 (18.12.96)
# @(#)Contact...Aldo Calpini <dada@divinf.it>
#

# history:
#^^^^^^^^^
# - 0.80.08 (18.12.96): . fixed a big bug in the list management...
#                         (thanx to Agustin Nunez Castain for the signalation).
# - 0.80.07 (02.12.96): . added an "Advanced" tab (handle with care :).
#                       . added import/export of local names, list users and aliases.
#                       . fixed a bug in the "Who Can Send" section of list management.
#                         (thanx to Ermanno Bonifazi for the signalation).
# - 0.80.04 (28.11.96): . supports multiple "Accept Mail For" and mailing list members
#                         adding and deletion
#                       . polished the source (removed some old stuff)
# - 0.80.02 (23.10.96): . better look of tabs
# - 0.80.00 (05.07.96): . first version - as featured in the Control Panel Applet

require "cgi-lib.pl";

print "HTTP/1.0 200 OK\n" if $ENV{"PERLXS"}=~/PerlIS/i;
print "Content-type: text/html\n\n";

use Win32::Registry;

$ME_URL=$ENV{'SCRIPT_NAME'};
# or give the absolute URL if you need to :)

&ReadParse(*IN);

if($IN{"tab"} eq undef) {
  if($IN{"_tab"} ne undef) {
    $IN{"tab"}=$IN{"_tab"};
  } else {
    $IN{"tab"}="Directories";
  }
}


$ME_NAME            = "IMSadmin";
$ME_VERSION         = "0.80.07";
$ME_AUTHOR          = "<A HREF=mailto:dada\@divinf.it>dada</A>";

$INACTIVE_TAB_COLOR = "#C0C0C0";
$ACTIVE_TAB_COLOR   = "white";
$DIALOG_FONT        =  "<FONT FACE=Arial SIZE=2>";


print "<HTML><HEAD><TITLE>EMWAC IMS 0.80 on \\\\";
print Win32::NodeName();
print "</TITLE></HEAD>\n";
print "<FORM ACTION=\"$ME_URL\" METHOD=get>\n";
&printTABS($IN{"tab"});


if($IN{'tab'} eq "Directories") {

    &IMSGetParameters;

    # update them
    if($IN{'do'} eq "    OK    ") {
      &RegUpdate($RegIMS,$IMS,"MailInBoxDir",REG_SZ,$IN{'mailboxdir'});
      &RegUpdate($RegIMS,$IMS,"MailSpoolDir",REG_SZ,$IN{'spooldir'});
      $mailboxauto=($IN{"mailboxauto"} eq "on") ? 1 : 0;
      &RegUpdate($RegIMS,$IMS,"AutoCreateInboxDir",REG_DWORD,$mailboxauto);
      &RegUpdate($RegIMS,$IMS,"PostMaster",REG_SZ,$IN{'postmaster'});
      
      # and re-get them
      $RegIMS->Close();
      undef $RegIMS;
      undef $IMS;
      &IMSGetParameters;
    }

    # set them to the default
    &RegSetDefault($IMS,"MailInBoxDir",REG_SZ,"%HOME%\\INETMAIL\\INBOX");
    &RegSetDefault($IMS,"AutoCreateInboxDir",REG_DWORD,1);
    &RegSetDefault($IMS,"MailSpoolDir",REG_SZ,$ENV{'SystemRoot'}."\\SYSTEM32\\EMWAC\\MAIL");
    &RegSetDefault($IMS,"PostMaster",REG_SZ,"administrator");

    # and print them
# HTML_BEGIN
    print <<HTML_END;
      <TABLE BORDER=0 WIDTH=100%>
      <TD>$DIALOG_FONT
      Mailbox Directory:<BR>
      <INPUT SIZE=40 TYPE=text NAME=mailboxdir VALUE="$$IMS{'MailInBoxDir'}[2]">
      <BR><BR>
HTML_END

    &printCheckbox("mailboxauto",ord($$IMS{"AutoCreateInboxDir"}[2]),1,
                   "Automatically Create Mailbox");

# HTML_BEGIN
    print <<HTML_END;
      <BR><BR>
      Mail Spool Directory:<BR>
      <INPUT SIZE=40 TYPE=text NAME=spooldir VALUE="$$IMS{'MailSpoolDir'}[2]">
      <BR><BR>
      Postmaster:<BR>
      <INPUT SIZE=40 TYPE=text NAME=postmaster VALUE="$$IMS{'PostMaster'}[2]">
      </TD><TR><TD ALIGN=center>
      <INPUT TYPE=submit NAME=do VALUE="    OK    ">&nbsp;&nbsp;
      <INPUT TYPE=reset VALUE=Cancel>
      </TD></TABLE>
HTML_END

    $RegIMS->Close();

} elsif($IN{'tab'} eq "Misc") {

  if($IN{'do'} eq "Import") {
    if($IN{'import_file'} eq undef) {
    
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>$DIALOG_FONT\n".
            "File name:<BR><INPUT SIZE=60 TYPE=text NAME=import_file><BR><BR>\n";
      print "Import Mode:<BR>\n".
            "<INPUT TYPE=radio NAME=import_mode CHECKED VALUE=add>Add<BR>\n".
            "<INPUT TYPE=radio NAME=import_mode VALUE=replace>Replace<BR>\n".
            "</TD>\n<TR>\n<TD ALIGN=center>".
            "<INPUT TYPE=hidden NAME=do VALUE=Import>\n".
            "<INPUT TYPE=hidden NAME=tab VALUE=Misc>\n".
            "<INPUT TYPE=submit VALUE=Import>\n".
            "</TD></TABLE>\n";

    } else {
      print "$DIALOG_FONT\n";
      $IN{'import_file'}=~s|\\|/|g;
      if(open(FILE,"<$IN{'import_file'}")) {
        &IMSGetParameters;
        @imported=();
        while(<FILE>) {
          chomp;
          push(@imported,$_) if $_ ne undef;
        }
        close(FILE);
        if($IN{'import_mode'} eq "replace") {
          $newaccept=join("\0",@imported);
        } else {
          $newaccept=$$IMS{'DomainNamesAreLocal'}[2];
          $newaccept.="\0" if $newaccept ne undef;
          $newaccept.=join("\0",@imported);
        }
        $RegIMS->SetValueEx("DomainNamesAreLocal",0,REG_MULTI_SZ,$newaccept) 
          || &printERROR("Error in setting DomainNamesAreLocal!");
        print "Import completed.<P>\n".
              "<INPUT TYPE=hidden NAME=tab VALUE=Misc>\n".
              "<INPUT TYPE=submit VALUE=Back>\n";
        $RegIMS->Close();
        undef $RegIMS;
      } else {
        &printERROR("Unable to open import file ($!).");
      }
    }

  } elsif($IN{'do'} eq "Export") {
    if($IN{'export_file'} eq undef) {
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>$DIALOG_FONT\n".
            "File name:<BR><INPUT SIZE=60 TYPE=text NAME=export_file></TD>\n".
            "<TR>\n<TD ALIGN=center>".
            "<INPUT TYPE=hidden NAME=do VALUE=Export>\n".
            "<INPUT TYPE=hidden NAME=tab VALUE=Misc>\n".
            "<INPUT TYPE=submit VALUE=Export>\n".
            "</TD></TABLE>\n";
    
    } else {
      print "$DIALOG_FONT\n";
      $IN{'export_file'}=~s|\\|/|g;
      if(open(FILE,">$IN{'export_file'}")) {
        &IMSGetParameters;
        @accepted=split(/\0/,$$IMS{"DomainNamesAreLocal"}[2]);
        foreach $elem (@accepted) {
          print FILE "$elem\n";
        }
        $RegIMS->Close();
        undef $RegIMS;
        close(FILE);
        print "Export completed.<P>\n".
              "<INPUT TYPE=hidden NAME=tab VALUE=Misc>\n".
              "<INPUT TYPE=submit VALUE=Back>\n";
      } else {
        &printERROR("Unable to open export file ($!).");
      }
    }
  } else {
    
    &IMSGetParameters;

    # update names
    if($IN{'do'} eq "Add") {

      if($IN{'newaccept'} ne undef) {
        @toadd=split(/\s+/,$IN{'newaccept'});
        @accepted=split(/\0/,$$IMS{'DomainNamesAreLocal'}[2]);
        push(@accepted,@toadd);
        # push(@accepted,$IN{'newaccept'});
        $newaccept=join("\0",@accepted);
        $RegIMS->SetValueEx("DomainNamesAreLocal",0,REG_MULTI_SZ,$newaccept) 
          || &printERROR("Error in setting DomainNamesAreLocal!");
      }
     
    } elsif($IN{'do'} eq "Delete") {

      if($IN{"accept"} ne undef) {
        @todel=split(/\0/,$IN{'accept'});
        @accepted=split(/\0/,$$IMS{'DomainNamesAreLocal'}[2]);
        foreach $elem (@accepted) {
          push(@newaccepted,$elem) if not grep(/$elem/,@todel);
        }
        $newaccept=join("\0",@newaccepted);
        $RegIMS->SetValueEx("DomainNamesAreLocal",0,REG_MULTI_SZ,$newaccept) 
          || &printERROR("Error in setting DomainNamesAreLocal!");
      }
    }

    # update other values & evtl. re-get them from registry
    if($IN{'do'} eq "    OK    " || $IN{'do'} eq "Delete" || $IN{'do'} eq "Add") {

      &RegUpdate($RegIMS,$IMS,"GatewayName",REG_SZ,$IN{"gateway"});
      $failures=0;
      $failures=1 if $IN{"failures"} eq "on";
      &RegUpdate($RegIMS,$IMS,"LocalFailuresToPostmaster",REG_DWORD,$failures);

      # re-get registry keys/values
      $RegIMS->Close();
      undef $RegIMS;
      undef $IMS;
      &IMSGetParameters;
    }

    # set them to the default

    &RegSetDefault($IMS,"GatewayName",REG_SZ,"");
    &RegSetDefault($IMS,"LocalFailuresToPostmaster",REG_DWORD,0);

    # and print them
    print "<TABLE BORDER=0 WIDTH=100%>\n".
          "<TD>$DIALOG_FONT\n".
          "SMTP Gateway Host:<BR><INPUT SIZE=40 TYPE=text NAME=gateway VALUE=\"$$IMS{'GatewayName'}[2]\"><BR><BR>\n";

    &printCheckbox("failures",ord($$IMS{'LocalFailuresToPostmaster'}[2]),1,
                   "Copy local failures to postmaster<BR><BR>\n");

    print "</TD><TD></TD><TR>\n".
          "<TD>${DIALOG_FONT}Accept Mail For:<BR>".
          "<SELECT MULTIPLE NAME=accept SIZE=10>\n";

    @accepted=split(/\0/,$$IMS{"DomainNamesAreLocal"}[2]);
    foreach $elem (@accepted) {
      print "<OPTION>$elem\n";
    }
    print "</SELECT><BR><BR>";

# HTML_BEGIN
    print <<HTML_END;
      </TD>
      <TD VALIGN=center ALIGN=center><INPUT TYPE=submit NAME=do VALUE=Delete><P>
      <INPUT TYPE=submit NAME=do VALUE=Import><P>
      <INPUT TYPE=submit NAME=do VALUE=Export></TD>
      <TR>
      <TD><INPUT SIZE=40 TYPE=text NAME=newaccept VALUE=""></TD>
      <TD VALIGN=center ALIGN=center><INPUT TYPE=submit NAME=do VALUE=Add></TD>
      <TR>
      <TD ALIGN=center COLSPAN=2>
      <INPUT TYPE=submit NAME=do VALUE="    OK    ">\&nbsp;\&nbsp;<INPUT TYPE=reset VALUE=Cancel>
      </TABLE>
HTML_END

    $RegIMS->Close();

  }

} elsif($IN{'tab'} eq "Lists") {

  if($IN{'members_do'} eq "Import" && $IN{'list'} ne undef) {
    if($IN{'import_file'} eq undef) {
    
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>$DIALOG_FONT\n".
            "File name:<BR><INPUT SIZE=60 TYPE=text NAME=import_file><BR><BR>\n";
      print "Import Mode:<BR>\n".
            "<INPUT TYPE=radio NAME=import_mode CHECKED VALUE=add>Add<BR>\n".
            "<INPUT TYPE=radio NAME=import_mode VALUE=replace>Replace<BR>\n".
            "</TD>\n<TR>\n<TD ALIGN=center>".
            "<INPUT TYPE=hidden NAME=list VALUE=\"$IN{'list'}\">\n".
            "<INPUT TYPE=hidden NAME=members_do VALUE=Import>\n".
            "<INPUT TYPE=hidden NAME=tab VALUE=Lists>\n".
            "<INPUT TYPE=submit VALUE=Import>\n".
            "</TD></TABLE>\n";

    } else {
      print "$DIALOG_FONT\n";
      $IN{'import_file'}=~s|\\|/|g;
      if(open(FILE,"<$IN{'import_file'}")) {

        &IMSGetList($IN{'list'});

        @imported=();
        while(<FILE>) {
          chomp;
          push(@imported,$_) if $_ ne undef;
        }
        close(FILE);
        if($IN{'import_mode'} eq "replace") {
          foreach $member (@members) {
            $RegMembers->DeleteKey($member);
          }
          undef @members;
        }
        foreach $newmember (@imported) {
          if(!grep(/^$newmember$/,@members)) {
            undef $RegNewMember;
            $RegMembers->Create($newmember,$RegNewMember) || &printERROR("Error in adding member $newmember!");
            $RegNewMember->Close();
          }
        }
        print "Import completed.<P>\n".
              "<INPUT TYPE=hidden NAME=tab VALUE=Lists>\n".
              "<INPUT TYPE=hidden NAME=do VALUE=Members>\n".
              "<INPUT TYPE=hidden NAME=list VALUE=\"$IN{'list'}\">\n".
              "<INPUT TYPE=submit VALUE=Back>\n";
        $RegList->Close();
        undef $RegList;
        $RegMembers->Close();
        undef $RegMembers;
      } else {
        &printERROR("Unable to open import file ($!).");
      }
    }

  } elsif($IN{'members_do'} eq "Export" && $IN{'list'} ne undef) {
    if($IN{'export_file'} eq undef) {
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>$DIALOG_FONT\n".
            "File name:<BR><INPUT SIZE=60 TYPE=text NAME=export_file></TD>\n".
            "<TR>\n<TD ALIGN=center>".
            "<INPUT TYPE=hidden NAME=list VALUE=\"$IN{'list'}\">\n".
            "<INPUT TYPE=hidden NAME=members_do VALUE=Export>\n".
            "<INPUT TYPE=hidden NAME=tab VALUE=Lists>\n".
            "<INPUT TYPE=submit VALUE=Export>\n".
            "</TD></TABLE>\n";
    
    } else {
      print "$DIALOG_FONT\n";
      $IN{'export_file'}=~s|\\|/|g;
      if(open(FILE,">$IN{'export_file'}")) {

        &IMSGetList($IN{'list'});

        foreach $elem (@members) {
          print FILE "$elem\n";
        }
        $RegList->Close();
        undef $RegList;
        $RegMembers->Close();
        undef $RegMembers;
        close(FILE);
        print "Export completed.<P>\n".
              "<INPUT TYPE=hidden NAME=tab VALUE=Lists>\n".
              "<INPUT TYPE=hidden NAME=do VALUE=Members>\n".
              "<INPUT TYPE=hidden NAME=list VALUE=\"$IN{'list'}\">\n".
              "<INPUT TYPE=submit VALUE=Back>\n";
      } else {
        &printERROR("Unable to open export file ($!).");
      }
    }

  } else {

    if(($IN{'members_do'} ne undef && $IN{'members_do'} ne "Cancel") 
    || ($IN{'do'} eq "Members" && $IN{'list'} ne undef) 
    || ($IN{'do'} eq "Add" && $IN{'newlist'} ne undef)) {

      if($IN{'do'} eq "Add") {
        $list=$IN{'newlist'};
        &IMSCreateList($list);
      } else {
        $list=$IN{'list'};
        &IMSGetList($list); 
      }

      # there are member(s) to delete
      if($IN{'members_do'} eq "Delete" && $IN{'member'} ne undef) {
      
        @todel=split(/\0/,$IN{'member'});
        foreach $member (@todel) {
          if(grep(/^$member$/,@members)) {
            $RegMembers->DeleteKey($member) || &printERROR("Error in deleting member $member!");
          }
        }
  
        # re-get the updated members list
        undef @members;
        $RegMembers->GetKeys(\@members) || &printERROR("Can\'t get members list!"); 
      }
  
      # there are member(s) to add
      if($IN{'members_do'} eq "Add" && $IN{'newmember'} ne undef) {
  
        @newmembers=split(/\s+/,$IN{'newmember'});
        foreach $newmember (@newmembers) {
          if(!grep(/^$newmember$/,@members)) {
            undef $RegNewMember;
            $RegMembers->Create($newmember,$RegNewMember) || &printERROR("Error in adding member $newmember!");
            $RegNewMember->Close();
          }
        }
  
        # re-get the updated members list
        undef @members;
        $RegMembers->GetKeys(\@members) || &printERROR("Can\'t get members list!");  
      }
  
      &RegSetDefault($IMSList,"BounceAction",REG_DWORD,0);
      &RegSetDefault($IMSList,"BouncesTo",REG_SZ,"");
      &RegSetDefault($IMSList,"ModeratorControlJoin",REG_DWORD,0);
      &RegSetDefault($IMSList,"ModeratorControlLeave",REG_DWORD,0);
      &RegSetDefault($IMSList,"Moderator",REG_SZ,"");
      &RegSetDefault($IMSList,"WhoCanSend",REG_DWORD,1);
    
      if(($IN{'do'} ne undef && $IN{'do'} ne "Members") || $IN{'members_do'} ne undef) {
        $reports=0 if $IN{"reports"} eq "discard";
        $reports=1 if $IN{"reports"} eq "return";
        $reports=2 if $IN{"reports"} eq "sendto";
        &RegUpdate($RegList,$IMSList,"BounceAction",REG_DWORD,$reports);
        &RegUpdate($RegList,$IMSList,"BouncesTo",REG_SZ,$IN{"sendto"});
        $controljoin=0;
        $controljoin=1 if $IN{"controljoin"} eq "on";
        &RegUpdate($RegList,$IMSList,"ModeratorControlJoin",REG_DWORD,$controljoin);
        $controlleave=0;
        $controlleave=1 if $IN{"controlleave"} eq "on";
        &RegUpdate($RegList,$IMSList,"ModeratorControlLeave",REG_DWORD,$controlleave);
        &RegUpdate($RegList,$IMSList,"Moderator",REG_SZ,$IN{"moderator"});
        $whocan=2 if $IN{"whocan"} eq "anyone";
        $whocan=1 if $IN{"whocan"} eq "member";
        $whocan=3 if $IN{"whocan"} eq "moderator";
        &RegUpdate($RegList,$IMSList,"WhoCanSend",REG_DWORD,$whocan);
    
        # re-get the registry values
        undef $IMSList;
        $RegList->GetValues($IMSList);
      }
  
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>${DIALOG_FONT}Mailing list name: <B>$list</B><BR><BR>\n".
            "<INPUT TYPE=hidden NAME=list VALUE=\"$list\">\n";
  
      print "Non-delivery reports:<BR>\n";
      &printRadio("reports",ord($$IMSList{'BounceAction'}[2]),0,"discard","Discard\&nbsp;\&nbsp;");
      &printRadio("reports",ord($$IMSList{'BounceAction'}[2]),1,"return","Return to sender<BR>\n");
      &printRadio("reports",ord($$IMSList{'BounceAction'}[2]),2,"sendto","Send to:\&nbsp;");
  
      print "<INPUT TYPE=text NAME=sendto VALUE=\"";
      print $$IMSList{'BouncesTo'}[2] if ord($$IMSList{'BounceAction'}[2]) eq 2;
      print "\"><BR><BR>\n";
  
      print "Moderated List:<BR>\n";
      &printCheckbox("controljoin",ord($$IMSList{'ModeratorControlJoin'}[2]),0,
                     "Moderator Control Join\&nbsp;\&nbsp;","ne");
      &printCheckbox("controlleave",ord($$IMSList{'ModeratorControlLeave'}[2]),0,
                     "Moderator Control Leave<BR>\n","ne");
  
      print "Moderator:\&nbsp;".
            "<INPUT TYPE=text NAME=moderator VALUE=\"$$IMSList{'Moderator'}[2]\"\"><BR>\n";
  
      print "Who can post: ";
      &printRadio("whocan",ord($$IMSList{"WhoCanSend"}[2]),2,"anyone","Anyone\&nbsp;\&nbsp;");
      &printRadio("whocan",ord($$IMSList{"WhoCanSend"}[2]),1,"member","Member\&nbsp;\&nbsp;");
      &printRadio("whocan",ord($$IMSList{"WhoCanSend"}[2]),3,"moderator","Moderator<BR><BR>\n");
  
      print "</TD><TD></TD><TR><TD>${DIALOG_FONT}\n";
  
      print "Membership:<BR><SELECT MULTIPLE NAME=member SIZE=10>\n";
      foreach $elem (@members) {
        print "<OPTION>$elem\n";
      }
      print "</SELECT>";
  
# HTML_BEGIN
      print <<HTML_END;
        </TD>
        <TD VALIGN=center ALIGN=center>
        <INPUT TYPE=submit NAME=members_do VALUE=Delete><P>
        <INPUT TYPE=submit NAME=members_do VALUE=Import><P>
        <INPUT TYPE=submit NAME=members_do VALUE=Export>
        </TD><TR>
        <TD>$DIALOG_FONT
          New Member(s):<BR><INPUT TYPE=text SIZE=40 NAME=newmember VALUE="">
        </TD>
        <TD VALIGN=bottom ALIGN=center>
          <INPUT TYPE=submit NAME=members_do VALUE=Add>
        </TD>
        <TR>
        <TD COLSPAN=2 ALIGN=center VALIGN=center>
          <INPUT TYPE=submit NAME=members_do VALUE="    OK    ">
          &nbsp;&nbsp;<INPUT TYPE=submit NAME=members_do VALUE="Cancel">
        </TD>
        </TABLE>
HTML_END
 
      $RegList->Close();
      $RegMembers->Close();
  
    # no list selected, show the lists dialog
    } else {
  
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD WIDTH=50%>${DIALOG_FONT}\n";
  
      # get mailing lists from registry
      $HKEY_LOCAL_MACHINE->Open("SOFTWARE\\EMWAC\\IMS\\Lists",$RegLists) 
        || &printERROR("Can\'t open EMWAC IMS registry!");
      $RegLists->GetKeys(\@listaliste) || &printERROR("Error in reading Mailing Lists!");
  
      $list=$IN{"list"};
      if($IN{'do'} eq "Delete" && $IN{'list'} ne undef && grep(/^$list$/,@listaliste) ne 0) {
        $RegLists->Open($list."\\Members",$RegMembers) 
          || &printERROR("Can\'t open members of Mailing list <B>$list</B>!");
        $RegMembers->GetKeys(\@members);
        foreach $elem (@members) {
          $RegMembers->DeleteKey($elem)
            || &printERROR("Can\'t delete member <B>$elem</B> from Mailing list <B>$list</B>!");
        }
        $RegMembers->Close();
        $RegLists->DeleteKey($list."\\Members")
          || &printERROR("Can\'t delete members of Mailing list $list!");
        $RegLists->DeleteKey($list) || &printERROR("Can\'t delete Mailing list <B>$list</B>!");
   
        # re-get mailing lists
        undef @listaliste;
        $RegLists->GetKeys(\@listaliste) || &printERROR("Error in reading Mailing Lists!");
      }
  
      print "Mailing Lists:<BR><SELECT NAME=list SIZE=10>\n";
      foreach $elem (@listaliste) {
        print "<OPTION>$elem\n";
      }
      print "</SELECT>";
  
# HTML_BEGIN
      print <<HTML_END;
        </TD>
        <TD ALIGN=center VALIGN=center WIDTH=50%>$DIALOG_FONT
          <INPUT TYPE=submit NAME=do VALUE=Members><BR><BR>
          <INPUT TYPE=submit NAME=do VALUE=Delete>
        </TD>
        <TR>
        <TD WIDTH=50%>$DIALOG_FONT
          New List Name:<BR><INPUT SIZE=40 TYPE=text NAME=newlist VALUE="">
        </TD>
        <TD WIDTH=50% VALIGN=bottom ALIGN=center>$DIALOG_FONT
          <INPUT TYPE=submit NAME=do VALUE=Add>
        </TD>
        </TABLE>
HTML_END
      
      $RegLists->Close();
    }  
  }

} elsif($IN{"tab"} eq "Aliases") {

  if($IN{'do'} eq "Import") {
    if($IN{'import_file'} eq undef) {
    
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>$DIALOG_FONT\n".
            "File name:<BR><INPUT SIZE=60 TYPE=text NAME=import_file><BR><BR>\n";
      print "Import Mode:<BR>\n".
            "<INPUT TYPE=radio NAME=import_mode CHECKED VALUE=add>Add<BR>\n".
            "<INPUT TYPE=radio NAME=import_mode VALUE=replace>Replace<BR>\n".
            "</TD>\n<TR>\n<TD ALIGN=center>".
            "<INPUT TYPE=hidden NAME=do VALUE=Import>\n".
            "<INPUT TYPE=hidden NAME=tab VALUE=Aliases>\n".
            "<INPUT TYPE=submit VALUE=Import>\n".
            "</TD></TABLE>\n";

    } else {
      print "$DIALOG_FONT\n";
      $IN{'import_file'}=~s|\\|/|g;
      if(open(FILE,"<$IN{'import_file'}")) {
        &IMSGetAliases;
        if($IN{'import_mode'} eq "replace") {
          foreach $elem (keys(%dbalias)) {
            $RegAliases->DeleteKey($elem) || &printERROR("Error deleting Alias <B>$elem</B>!");
          }
          undef %dbalias;
        }
        while(<FILE>) {
          chomp;
          ($alias,$mapto)=split(/:/,$_,2);
          # add as new alias...
          $new=keys(%dbalias)+1;
          # ... unless it is already defined
          foreach $elem (keys(%dbalias)) {
            ($cmp_alias,$cmp_mapto)=split(/: /,$dbalias{$elem},2);
            if($alias eq $cmp_alias) {
              $new=$elem;
            }
          }
          $dbalias{$new}=$alias.": ".$mapto;
          # print "(re)writing alias <B>$new</B><BR>\n";
          undef $RegNewAlias;
          $RegAliases->Create($new,$RegNewAlias) || &printERROR("Error creating Alias <B>$new</B>!");
          $RegNewAlias->SetValueEx("Alias",0,REG_SZ,$alias) || &printERROR("Error creating Alias <B>$new</B>!");
          $RegNewAlias->SetValueEx("MappedTo",0,REG_SZ,$mapto) || &printERROR("Error creating Alias <B>$new</B>!");
          $RegNewAlias->Close();
        }
        close(FILE);
        print "Import completed.<P>\n".
              "<INPUT TYPE=hidden NAME=tab VALUE=Aliases>\n".
              "<INPUT TYPE=submit VALUE=Back>\n";
        $RegIMS->Close();
      } else {
        &printERROR("Unable to open import file ($!).");
      }
    }

  } elsif($IN{'do'} eq "Export") {
    if($IN{'export_file'} eq undef) {
      print "<TABLE BORDER=0 WIDTH=100%>\n".
            "<TD>$DIALOG_FONT\n".
            "File name:<BR><INPUT SIZE=60 TYPE=text NAME=export_file></TD>\n".
            "<TR>\n<TD ALIGN=center>".
            "<INPUT TYPE=hidden NAME=do VALUE=Export>\n".
            "<INPUT TYPE=hidden NAME=tab VALUE=Aliases>\n".
            "<INPUT TYPE=submit VALUE=Export>\n".
            "</TD></TABLE>\n";
    
    } else {
      print "$DIALOG_FONT\n";
      $IN{'export_file'}=~s|\\|/|g;
      if(open(FILE,">$IN{'export_file'}")) {
        &IMSGetAliases;
        foreach $elem (@aliases) {
          print FILE "$dbalias{$elem}\n";
        }
        $RegAliases->Close();
        undef $RegAliases;
        close(FILE);
        print "Export completed.<P>\n".
              "<INPUT TYPE=hidden NAME=tab VALUE=Aliases>\n".
              "<INPUT TYPE=submit VALUE=Back>\n";
      } else {
        &printERROR("Unable to open export file ($!).");
      }
    }

  } else {

    print "<TABLE BORDER=0 WIDTH=100%>\n".
          "<TD COLSPAN=2>${DIALOG_FONT}\n";

    &IMSGetAliases;
  
    $alias=$IN{'alias'};
    if($IN{'do'} eq "Delete" && $alias ne undef && grep(/^$alias$/,@aliases) ne 0) {
      # delete the alias
      $RegAliases->DeleteKey($IN{'alias'}) || &printERROR("Error deleting Alias <B>$IN{'alias'}</B>!");
      # renumber the aliases after the one deleted
      # print "deleted alias <B>$alias</B> on <B>$#aliases</B><BR>\n";
      if($alias lt ($#aliases+1)) {
        for($i=$alias;$i<$#aliases+1;$i++) {
          $j=$i+1;
          ($alias,$mappedto)=split(/: /,$dbalias{$j},2);
          # print $j," (<B>$dbalias{$j}</B>): $alias, $mappedto --\&gt; $i<BR>\n";
          $RegAliases->Create($i,$RegNewAlias) || &printERROR("Error creating Alias <B>$i</B>!");
          $RegNewAlias->SetValueEx("Alias",0,REG_SZ,$alias) || &printERROR("Error creating Alias <B>$i</B>!");
          $RegNewAlias->SetValueEx("MappedTo",0,REG_SZ,$mappedto) || &printERROR("Error creating Alias <B>$i</B>!");
          $RegNewAlias->Close();
          $RegAliases->DeleteKey($j) || &printERROR("Error deleting Alias <B>$j</B>!");
        }
      }
    }

    if($IN{'do'} eq "Set" && $IN{'newalias'} ne undef && $IN{'newmapto'} ne undef) {
      # add as new alias...
      $new=keys(%dbalias)+1;
      # ... unless it is already defined
      foreach $elem (keys(%dbalias)) {
        ($alias,$mappedto)=split(/: /,$dbalias{$elem},2);
        if($alias eq $IN{'newalias'}) {
          $new=$elem;
        }
      }
      # print "(re)writing alias <B>$new</B><BR>\n";
      $RegAliases->Create($new,$RegNewAlias) || &printERROR("Error creating Alias <B>$new</B>!");
      $RegNewAlias->SetValueEx("Alias",0,REG_SZ,$IN{'newalias'}) || &printERROR("Error creating Alias <B>$new</B>!");
      $RegNewAlias->SetValueEx("MappedTo",0,REG_SZ,$IN{'newmapto'}) || &printERROR("Error creating Alias <B>$new</B>!");
      $RegNewAlias->Close();
    }


    if($IN{'do'} eq "  Up  " && $IN{'alias'} gt 1) {
      $from=$IN{'alias'};
      $to=$from-1;
      $RegAliases->Open($from,$RegFromAlias) || &printERROR("Error opening Alias (from) <B>$from</B>!");
      $RegAliases->Open($to,$RegToAlias) || &printERROR("Error opening Alias (to) <B>$to</B>!");
      ($alias,$mappedto)=split(/: /,$dbalias{$to},2);
      $RegFromAlias->SetValueEx("Alias",0,REG_SZ,$alias) || &printERROR("Error setting Alias <B>$from</B>!");
      $RegFromAlias->SetValueEx("MappedTo",0,REG_SZ,$mappedto) || &printERROR("Error setting Alias <B>$from</B>!");
      ($alias,$mappedto)=split(/: /,$dbalias{$from},2);
      $RegToAlias->SetValueEx("Alias",0,REG_SZ,$alias) || &printERROR("Error setting Alias <B>$to</B>!");
      $RegToAlias->SetValueEx("MappedTo",0,REG_SZ,$mappedto) || &printERROR("Error setting Alias <B>$to</B>!");
      $IN{"alias"}=$to;
    }

    if($IN{'do'} eq "Down" && $IN{'alias'} lt $#aliases+1) {
      $from=$IN{'alias'};
      $to=$from+1;
      $RegAliases->Open($from,$RegFromAlias) || &printERROR("Error opening Alias <B>$from</B>!");
      $RegAliases->Open($to,$RegToAlias) || &printERROR("Error opening Alias <B>$to</B>!");
      ($alias,$mappedto)=split(/: /,$dbalias{$to},2);
      $RegFromAlias->SetValueEx("Alias",0,REG_SZ,$alias) || &printERROR("Error setting Alias <B>$from</B>!");
      $RegFromAlias->SetValueEx("MappedTo",0,REG_SZ,$mappedto) || &printERROR("Error setting Alias <B>$from</B>!");
      ($alias,$mappedto)=split(/: /,$dbalias{$from},2);
      $RegToAlias->SetValueEx("Alias",0,REG_SZ,$alias) || &printERROR("Error setting Alias <B>$to</B>!");
      $RegToAlias->SetValueEx("MappedTo",0,REG_SZ,$mappedto) || &printERROR("Error setting Alias <B>$to</B>!");
      $IN{'alias'}=$to;
    }

    if($IN{'do'} ne undef) {
      # re-get aliases from registry
      &IMSGetAliases;
    }

# HTML_BEGIN
    print <<HTML_END;
    Local host alias table:<BR><SELECT 
    onChange="w=this.options[this.selectedIndex].text; 
              walias=w.substring(0,w.indexOf(': ')); 
              wmapto=w.substring(w.indexOf(': ')+2,w.length);
              document.forms[0].elements[6].value=walias;
              document.forms[0].elements[9].value=wmapto;"
    NAME=alias SIZE=10>
HTML_END

    foreach $elem (keys(%dbalias)) {
      print "<OPTION ";
      print "SELECTED " if $elem eq $IN{"alias"}
                        && ($IN{'do'} eq "Set" || $IN{'do'} eq "  Up  " || $IN{'do'} eq "Down");
      print "VALUE=\"$elem\">$dbalias{$elem}\n";
    }

    if($dbalias{$IN{'alias'}} ne undef) {
      ($alias,$mapto)=split(/: /,$dbalias{$IN{'alias'}},2);
    } else {
      $alias="";
      $mapto="";
    }

# HTML_BEGIN
    print <<HTML_END;
      </SELECT>
      </TD>
      <TD VALIGN=center ALIGN=center>
        <INPUT TYPE=submit NAME=do VALUE="  Up  "><BR>
        <INPUT TYPE=submit NAME=do VALUE=Down><P>
        <INPUT TYPE=submit NAME=do VALUE=Import><BR>
        <INPUT TYPE=submit NAME=do VALUE=Export>
      </TD>
      <TR>
      <TD>$DIALOG_FONT
        User name:
      </TD>
      <TD><INPUT TYPE=text SIZE=40 NAME=newalias VALUE="$alias"><BR></TD>
      <TD ROWSPAN=2 VALIGN=bottom ALIGN=center>
        <INPUT TYPE=submit NAME=do VALUE=Set><BR>
        <INPUT TYPE=submit NAME=do VALUE=Delete>
      </TD>
      <TR>
      <TD>$DIALOG_FONT
        Map to:
      </TD>
      <TD><INPUT TYPE=text SIZE=40 NAME=newmapto VALUE="$mapto"><BR></TD>
      </TABLE>
HTML_END

    $RegAliases->Close();
  }

} elsif($IN{"tab"} eq "Logging") {

  &IMSGetServicesParameters;
  
  if($IN{'do'} eq "    OK    ") {

    $smtprlog=($IN{'smtprlog'} eq "on") ? 1 : 0;
    &RegUpdate($RegSMTPR,$IMSSMTPR,"MailInlogEnabled",REG_DWORD,$smtprlog);

    $smtpdlog=($IN{'smtpdlog'} eq "on") ? 1 : 0;
    &RegUpdate($RegSMTPD,$IMSSMTPD,"MailOutlogEnabled",REG_DWORD,$smtpdlog);

    $pop3log=($IN{'pop3log'} eq "on") ? 1 : 0;
    &RegUpdate($RegPOP3,$IMSPOP3,"Pop3LogEnabled",REG_DWORD,$pop3log);

    # re-get registry values
    undef $IMSSMTPR;
    undef $IMSSMTPD;
    undef $IMSPOP3;
    &IMSGetServicesParameters;
    
  }
  print "<TABLE BORDER=0 WIDTH=100%>\n".
        "<TD WIDTH=50%>${DIALOG_FONT}\n";

  &printCheckbox("pop3log",ord($$IMSPOP3{"Pop3LogEnabled"}[2]),0,
                 "POP3 Log Enabled<BR><BR>\n","ne");
  &printCheckbox("smtprlog",ord($$IMSSMTPR{"MailInlogEnabled"}[2]),0,
                 "SMTP Inlog Enabled<BR><BR>\n","ne");
  &printCheckbox("smtprlog",ord($$IMSSMTPD{"MailOutlogEnabled"}[2]),0,
                 "STMP Outlog Enabled<BR><BR>\n","ne");

  print "</TD><TR><TD VALIGN=center ALIGN=center>\n".
        "<INPUT TYPE=submit NAME=do VALUE=\"    OK    \">\n".
        "\&nbsp;\&nbsp;<INPUT TYPE=reset VALUE=Cancel>\n".
        "</TD></TABLE>\n";

  $RegSMTPR->Close();
  $RegSMTPD->Close();
  $RegPOP3->Close();

} elsif($IN{"tab"} eq "Advanced") {

  &IMSGetServicesParameters;
  
  if($IN{'do'} eq "    OK    ") {

    $RegSMTPR->SetValueEx("PortNo",0,REG_DWORD,$IN{'smtpr_port'}) 
      || &printERROR("Error setting registry value <B>PortNo</B>!");

    $smtpr_check=($IN{'smtpr_check'} eq "on") ? 1 : 0;
    $RegSMTPR->SetValueEx("CheckLocalRecipient",0,REG_DWORD,$smtpr_check) 
      || &printERROR("Error setting registry value <B>CheckLocalRecipient</B>!");

    $smtpr_relay=($IN{'smtpr_relay'} eq "on") ? 1 : 0;
    $RegSMTPR->SetValueEx("ProhibitMailRelay",0,REG_DWORD,$smtpr_relay) 
      || &printERROR("Error setting registry value <B>ProhibitMailRelay</B>!");

    $RegSMTPD->SetValueEx("Timeout",0,REG_DWORD,$IN{'smtpd_timeout'}) 
      || &printERROR("Error setting registry value <B>Timeout</B>!");

    $RegPOP3->SetValueEx("PortNo",0,REG_DWORD,$IN{'pop3_port'}) 
      || &printERROR("Error setting registry value <B>PortNo</B>!");

    $RegPOP3->SetValueEx("MessageExtension",0,REG_SZ,$IN{'pop3_msg'}) 
      || &printERROR("Error setting registry value <B>MessageExtension</B>!");

    $RegPOP3->SetValueEx("Timeout",0,REG_DWORD,$IN{'pop3_timeout'}) 
      || &printERROR("Error setting registry value <B>Timeout</B>!");

    # re-get registry values
    undef $IMSSMTPR;
    undef $IMSSMTPD;
    undef $IMSPOP3;
    &IMSGetServicesParameters;
  }

  $smtpr_port=&RegGetDWORD($$IMSSMTPR{'PortNo'}[2],25);
  $smtpr_check=&RegGetDWORD($$IMSSMTPR{'CheckLocalRecipient'}[2],0);
  $smtpr_relay=&RegGetDWORD($$IMSSMTPR{'ProhibitMailRelay'}[2],0);

  $smtpd_timeout=&RegGetDWORD($$IMSSMTPD{'Timeout'}[2],120);
          
  $pop3_port=&RegGetDWORD($$IMSPOP3{'PortNo'}[2],110);
  $pop3_msg=$$IMSPOP3{'MessageExtension'}[2];
  $pop3_msg="MSG" if $pop3_msg eq undef;
  $pop3_timeout=&RegGetDWORD($$IMSPOP3{'Timeout'}[2],600);

# HTML_BEGIN
  print <<HTML_END;
    <TABLE BORDER=0 WIDTH=100%>
    <TD COLSPAN=3>$DIALOG_FONT
      <B>SMTP Receiver:
    </TD>
    <TR>
    <TD WIDTH=2%></TD><TD NOWRAP WIDTH=1%>$DIALOG_FONT
      Port Number:</TD><TD><INPUT TYPE=text NAME=smtpr_port VALUE=$smtpr_port onFocus="this.select();">
    </TD>
    <TR><TD WIDTH=2%></TD><TD COLSPAN=3>$DIALOG_FONT
HTML_END

    &printCheckbox("smtpr_check",$smtpr_check,0,"Check Local Recipient<BR>\n","ne");
    &printCheckbox("smtpr_relay",$smtpr_relay,0,"Prohibit Mail Relay<BR>\n","ne");

# HTML_BEGIN
  print <<HTML_END;
    </TD><TR><TD COLSPAN=3>$DIALOG_FONT
      <B>SMTP Delivery Agent:
    </TD>
    <TR>
    <TD WIDTH=2%></TD><TD NOWRAP WIDTH=1%>$DIALOG_FONT
      Timeout:</TD><TD><INPUT TYPE=text NAME=smtpd_timeout VALUE=$smtpd_timeout onFocus="this.select();">
    </TD>
    <TR><TD COLSPAN=3>$DIALOG_FONT
      <B>POP3 Server:
    </TD>
    <TR>
    <TD WIDTH=2%></TD><TD NOWRAP WIDTH=1%>$DIALOG_FONT
      Port Number:</TD><TD><INPUT TYPE=text NAME=pop3_port VALUE=$pop3_port onFocus="this.select();">
    </TD>
    <TR><TD WIDTH=2%></TD><TD NOWRAP WIDTH=1%>$DIALOG_FONT
      Timeout:</TD><TD><INPUT TYPE=text NAME=pop3_timeout VALUE=$pop3_timeout onFocus="this.select();">
    </TD>
    <TR><TD WIDTH=2%></TD><TD NOWRAP WIDTH=1%>$DIALOG_FONT
      Message Extension:</TD><TD><INPUT TYPE=text NAME=pop3_msg VALUE=$pop3_msg onFocus="this.select();">
    </TD>

    <TR>
    <TD COLSPAN=3 VALIGN=center ALIGN=center>
      <INPUT TYPE=submit NAME=do VALUE="    OK    ">
      &nbsp;&nbsp;
      <INPUT TYPE=reset VALUE=Cancel>
    </TD></TABLE>
HTML_END

  $RegSMTPR->Close();
  $RegSMTPD->Close();
  $RegPOP3->Close();
}


print "<HR></FORM>\n".
      "<FONT FACE=Arial SIZE=1>$ME_NAME $ME_VERSION by $ME_AUTHOR\n".
      "</BODY>\n</HTML>\n";

###############################################################################################
# SUBROUTINES
###############################################################################################

#===============
sub printERROR {
#===============
  local($text)=@_;
  print "</TD></TABLE></FORM><P>\n".
        "<HR><FONT COLOR=red><B>ERROR</B></FONT>\n".
        "<DL><DT>$text<BR>\n";
  # print "<DD><B>";
  # print Win32::GetLastError();
  # print "</B>";
  print "</DL><HR></BODY></HTML>\n";
  exit(0);
}

#==============
sub printTABS {
#==============
  local($tab)=@_;
  print "<TABLE BORDER=1 CELLSPACING=0>\n";
  &printATAB($tab,"Directories");
  &printATAB($tab,"Misc");
  &printATAB($tab,"Lists");
  &printATAB($tab,"Aliases");
  &printATAB($tab,"Logging");
  &printATAB($tab,"Advanced");
  print "</TABLE>\n";
  print "<HR>\n";
}

#==============
sub printATAB {
#==============
  local($tab,$name)=@_;
  if($tab eq $name) {
    print "<TD BGCOLOR=\"$ACTIVE_TAB_COLOR\">";
    print "\&nbsp;<INPUT TYPE=hidden NAME=_tab VALUE=$name>${DIALOG_FONT}$name\&nbsp;</TD>\n";
  } else {
    # print "<TD BGCOLOR=\"#C0C0C0\">${DIALOG_FONT}<INPUT TYPE=submit NAME=tab VALUE=$name></TD>\n";
    print "<TD BGCOLOR=\"$INACTIVE_TAB_COLOR\">\&nbsp;${DIALOG_FONT}<A HREF=\"$ME_URL\?tab=$name\">$name</A>\&nbsp;</TD>\n";
  }
}

#===============
sub printRadio {
#===============
  local($name,$compare1,$compare2,$value,$text)=@_;

  print "<INPUT TYPE=radio NAME=\"$name\" ";
  print "CHECKED " if $compare1 eq $compare2;
  if($text eq undef) {
    print ">$value";
  } else {
    print " VALUE=\"$value\">$text";
  }
}

#==================
sub printCheckbox {
#==================
  local($name,$compare1,$compare2,$text,$reversecompare)=@_;

  print "<INPUT TYPE=checkbox NAME=\"$name\" ";
  if($reversecompare eq undef) {
    print "CHECKED " if $compare1 eq $compare2;
  } else {
    print "CHECKED " if $compare1 ne $compare2;
  }
  print "> $text";
}

#==================
sub RegSetDefault {
#==================
  local($Key,$Name,$Type,$Value)=@_;
  local $aref;

  if($Key->{$Name}->[0] eq undef) {
    # print "<B>DEFAULTING $Name...</B><BR>\n";
    $aref=[$Name,$Type,$Value];
    $_[0]->{$Name}=$aref;
  }
}

#==============
sub RegUpdate {
#==============
  local($Key,$Values,$Name,$Type,$Value)=@_;
  local $aref;

  if($Type eq REG_DWORD && $Value ne ord($Values->{$Name}->[2])) {
    $_[0]->SetValueEx($Name,0,REG_DWORD,$Value) || &printERROR("Error setting registry value <B>$Name</B>!");
  }

  if($Type eq REG_SZ && $Value ne $Values->{$Name}->[2]) {
    $_[0]->SetValueEx($Name,0,REG_SZ,$Value) || &printERROR("Error setting registry value <B>$Name</B>!");
  }
}

#================
sub RegGetDWORD {
#================
  my($value,$default)=@_;
  my $result=0;
  my $i=0;

  if($value eq undef) {
    $result=$default;
  } else {
    foreach $i (0..length($value)) {
      $result=$result+(ord(substr($value,$i,1))*(($i==0) ? 1 : ($i*256)));
      # print "RegGetDWORD.c=",ord(substr($value,$i,1))," result=$result<BR>\n";
    }
  }
  return $result;
}

#==================
sub IMSGetAliases {
#==================
  undef %dbalias;
  undef @aliases;
  # get aliases from registry
  if($RegAliases eq undef) {
    $HKEY_LOCAL_MACHINE->Open("SOFTWARE\\EMWAC\\IMS\\Aliases",$RegAliases) 
      || &printERROR("Can\'t open EMWAC IMS registry!");
  }
  $RegAliases->GetKeys(\@aliases) || &printERROR("Error in reading Aliases!");
  foreach $elem (@aliases) {
    $RegAliases->Open($elem,$RegAlias) || &printERROR("Error opening Alias <B>$elem</B>!");
    $RegAlias->GetValues($IMSAlias) || &printERROR("Error reading Alias <B>$elem</B>!");
    $alias=$$IMSAlias{"Alias"}[2];
    $mappedto=$$IMSAlias{"MappedTo"}[2];
    $dbalias{$elem}=$alias.": ".$mappedto;
    $RegAlias->Close();
    undef $RegAlias;
    undef $IMSAlias;
  }
}

#=====================
sub IMSGetParameters {
#=====================
  # get registry keys/values
  if($RegIMS eq undef) {
    $HKEY_LOCAL_MACHINE->Open("SOFTWARE\\EMWAC\\IMS",$RegIMS)
      || &printERROR("Cant'open EMWAC IMS registry!");
  }
  undef $IMS;
  $RegIMS->GetValues($IMS) || &printERROR("Error in reading IMS parameters!");
}

#=============================
sub IMSGetServicesParameters {
#=============================
  if($RegSMTPR eq undef) {
    $HKEY_LOCAL_MACHINE->Open("SYSTEM\\CurrentControlSet\\Services\\SMTPRS\\Parameters",$RegSMTPR) 
      || &printERROR("Cant'open EMWAC IMS registry!");
  }
  if($RegSMTPD eq undef) {
    $HKEY_LOCAL_MACHINE->Open("SYSTEM\\CurrentControlSet\\Services\\SMTPDS\\Parameters",$RegSMTPD) 
      || &printERROR("Cant'open EMWAC IMS registry!");
  }
  if($RegPOP3 eq undef) {
    $HKEY_LOCAL_MACHINE->Open("SYSTEM\\CurrentControlSet\\Services\\POP3S\\Parameters",$RegPOP3) 
      || &printERROR("Cant'open EMWAC IMS registry!");
  }
  $RegSMTPR->GetValues($IMSSMTPR) || &printERROR("Error in reading SMTP Receiver parameters!");
  $RegSMTPD->GetValues($IMSSMTPD) || &printERROR("Error in reading SMTP Delivery Agent parameters!");
  $RegPOP3->GetValues($IMSPOP3) || &printERROR("Error in reading POP3 parameters!");
}

#===============
sub IMSGetList {
#===============
  my($list)=@_;
  if($RegList eq undef) {
    $HKEY_LOCAL_MACHINE->Open("SOFTWARE\\EMWAC\\IMS\\Lists\\".$list,$RegList) 
      || &printERROR("Can\'t open Mailing list $list!");
  }
  undef $IMSList;
  $RegList->GetValues($IMSList) 
    || &printERROR("Can\'t read Mailing list $list parameters!");
  if($RegMembers eq undef) {
    $RegList->Open("Members",$RegMembers) 
      || &printERROR("Can\'t open members of Mailing list $list!");
  }
  undef @members;
  $RegMembers->GetKeys(\@members) 
    || &printERROR("Can\'t get members list for Mailing list $list!"); 
}

#==================
sub IMSCreateList {
#==================
  my($list)=@_;
  if($RegList eq undef) {
    $HKEY_LOCAL_MACHINE->Create("SOFTWARE\\EMWAC\\IMS\\Lists\\".$list,$RegList) 
      || &printERROR("Can\'t open Mailing list $list!");
  }
  undef $IMSList;
  $RegList->GetValues($IMSList) 
    || &printERROR("Can\'t read Mailing list $list parameters!");
  if($RegMembers eq undef) {
    $RegList->Create("Members",$RegMembers) 
      || &printERROR("Can\'t open members of Mailing list $list!");
  }
  undef @members;
  $RegMembers->GetKeys(\@members) 
    || &printERROR("Can\'t get members list for Mailing list $list!"); 
}
